# This file contains a JSONSchema to validate the values given
# as inputs to the chart.
#
# **** How to edit this file *****
#
# This file is encoded as YAML instead of JSON to allow comments,
# and make editing and diffing easier.
#
# The values.schema.json file is the file actually used by the Helm chart
# and MUST BE RECREATED after each modification of this file:
#
#   ./utils/_yaml2json.py < values.schema.yaml > values.schema.json
#
# You can test that this file is a valid JSONSchema with:
#
#   utils/_yaml2json.py < values.schema.yaml > values.schema.json && python -m jsonschema -o pretty /usr/lib/python3/dist-packages/jsonschema/schemas/draft2020-12.json -i values.schema.json
#
# **** How to test that values.yaml files conform to this schema ****
#
# Helm template will do this validation:
#
#  utils/_yaml2json.py < values.schema.yaml > values.schema.json && helm template . --values values.yaml
#
# You can also use another JSONSchema validation tool (it's useful to have more detailed answers than what Helm produces):
#
#   To test the chart default values.yaml:
#
#      utils/_yaml2json.py < values.schema.yaml > values.schema.json && \
#        utils/_yaml2json.py < values.yaml | python -m jsonschema -o pretty values.schema.json -i /dev/stdin
#
#   To test the combination of the default values.yaml combined with other values files:
#
#      utils/_yaml2json.py < values.schema.yaml > values.schema.json && \
#        utils/_yaml-merge.py -o json values.yaml foo.yaml | python -m jsonschema -o pretty values.schema.json -i /dev/stdin
#


$schema: https://json-schema.org/draft/2020-12/schema#

title: Schema for sylva-capi-cluster chart values

# this description is formatted so that it will appear very clearly
# in the JSON counterpart that the JSON isn't meant to be edited
description:
  ----------------------------------------------------------------------
  DO NOT EDIT THIS FILE AS JSON, THE YAML VERSION IS THE SOURCE OF TRUTH
  ----------------------------------------------------------------------
# sub-schemas used later on in the actual schema
$defs:
  ipv4-cidr:
    type: string
    pattern: ^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)(?:\/([1-9]|[12]\d|3[01]))$

  ipv4-cidr-full:
    type: string
    pattern: ^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)(?:\/([1-9]|[12]\d|3[012]))$

  ipv4-range:
    type: string
    pattern: ^(?:(?:[01]?[0-9]{1,2}|2[0-4][0-9]|25[0-5])\.){3}(?:[01]?[0-9]{1,2}|2[0-4][0-9]|25[0-5])-(?:(?:[01]?[0-9]{1,2}|2[0-4][0-9]|25[0-5])\.){3}(?:[01]?[0-9]{1,2}|2[0-4][0-9]|25[0-5])$

  ipv4-prefix:
    anyOf:
      - type: integer
        minimum: 0
        maximum: 32
      - type: string
        pattern: ^([0-9]|[12]\d|3[012])$

  capm3-NetworkDataRoutev4:
    type: array
    items:
      type: object
      additionalProperties: false
      required:
        - network
        - prefix
        - gateway
      properties:
        network: # -------------------------------
          type: string
          format: ipv4
        prefix: # -------------------------------
          $ref: "#/$defs/ipv4-prefix"
        gateway: # -------------------------------
          type: object
          additionalProperties: false
          properties:
            string: # -------------------------------
              type: string
              format: ipv4
            fromIPPool: # -------------------------------
              type: string
        services: # -------------------------------
          type: object
          additionalProperties: false
          properties:
            dns: # -------------------------------
              type: array
              items:
                anyOf:
                  - type: string
                    format: ipv4
                  - type: string
                    format: hostname
            dnsFromIPPool: # -------------------------------
              type: string

  capo-machine-rootVolume:  # -------------------------------
    type: object
    additionalProperties: false
    properties:

      diskSize:  # -------------------------------
        type: integer

      volumeType:  # -------------------------------
        type: string

  capv-machine:  # -------------------------------
    type: object
    additionalProperties: false
    properties:

      image_name:  # -------------------------------
        type: string

      diskGiB:  # -------------------------------
        type: integer

      memoryMiB:  # -------------------------------
        type: integer

      numCPUs:  # -------------------------------
        type: integer

  capm3-machine:  # -------------------------------
    type: object
    properties:

      machine_image_url:  # -------------------------------
        type: string
        pattern: "^(https?://.*|)$"

      machine_image_format:  # -------------------------------
        type: string

      machine_image_checksum:  # -------------------------------
        type: string
        pattern: "^(https?://.*|)$"

      machine_image_checksum_type:  # -------------------------------
        type: string

      provisioning_pool_interface:  # -------------------------------
        type: string

      public_pool_interface:  # -------------------------------
        type: string

      networkData:  # -------------------------------
        type: object
        additionalProperties: false
        properties:

          provisioning_pool_interface:  # -------------------------------
            type: object
            properties:
              routes: # -------------------------------
                $ref: "#/$defs/capm3-NetworkDataRoutev4"

          public_pool_interface:  # -------------------------------
            type: object
            properties:
              routes: # -------------------------------
                $ref: "#/$defs/capm3-NetworkDataRoutev4"

      hostSelector:  # -------------------------------
        type: object

  rke2:  # -------------------------------
    type: object
    additionalProperties: false
    properties:

      additionalUserData:  # -------------------------------
        type: object
        additionalProperties: false
        properties:

          strict:  # -------------------------------
            type: boolean

          config:  # -------------------------------
            type: object

      nodeLabels:  # -------------------------------
        type: object

  kubeadm-users:  # -------------------------------
    type: object
    properties:

      users:  # -------------------------------
        type: array
        items:
          type: object
          required:
            - name
            - groups
            - sudo
            - shell
            - sshAuthorizedKeys

  bootstrap-additional-commands:  # -------------------------------
    type: object
    properties:

      pre_bootstrap_commands: # -------------------------------
        type: array
        items:
          type: string

      post_bootstrap_commands: # -------------------------------
        type: array
        items:
          type: string

  container-image:  # -------------------------------
    type: object
    properties:

      repository: # -------------------------------
        type: string

      tag: # -------------------------------
        type: string

  baremetal-host: # -------------------------------
    type: object
    additionalProperties: false
    properties:

      credentials:  # -------------------------------
        type: object
        additionalProperties: false
        properties:

          username:  # -------------------------------
            type: string

          password:  # -------------------------------
            type: string

      bmh_metadata:  # -------------------------------
        type: object
        properties:

          labels:  # -------------------------------
            type: object

          annotations:  # -------------------------------
            type: object

      bmh_spec:  # -------------------------------
        type: object
        # can't use required since it will enforce definition on both .baremetal_hosts & .baremetal_host_default
        # required:
        #   - automatedCleaningMode
        #   - bmc
        #   - bootMACAddress
        #   - bootMode
        #   - externallyProvisioned
        #   - rootDeviceHints
        properties:
          automatedCleaningMode: # -------------------------------
            type: string
          bmc: # -------------------------------
            type: object
            additionalProperties: false
            # can't use required since it will enforce definition on both .baremetal_hosts & .baremetal_host_default
            # required:
            #   - address
            properties:
              address: # -------------------------------
                type: string
              credentialsName: # -------------------------------
                type: string
              disableCertificateVerification: # -------------------------------
                type: boolean
          bootMACAddress: # -------------------------------
            type: string
          bootMode: # -------------------------------
            type: string
          description: # -------------------------------
            type: string
          externallyProvisioned: # -------------------------------
            type: boolean
          rootDeviceHints: # -------------------------------
            type: object
            # more available at https://github.com/metal3-io/baremetal-operator/blob/main/docs/api.md#rootdevicehints but enforcing these
            anyOf:
              - required:
                - hctl
              - required:
                - deviceName
            properties:
              hctl: # -------------------------------
                type: string
              deviceName: # -------------------------------
                type: string

  machine-deployment: # -------------------------------
    type: object
    additionalProperties: false
    properties:

      infra_provider:  # -------------------------------
        type: string

      replicas:  # -------------------------------
        type: integer

      metadata:  # -------------------------------
        type: object
        properties:

          labels:  # -------------------------------
            type: object

          annotations:  # -------------------------------
            type: object

      kubelet_extra_args:  # -------------------------------
        type: object

      rke2:  # -------------------------------
        $ref: "#/$defs/rke2"

      kubeadm:  # -------------------------------
        $ref: "#/$defs/kubeadm-users"

      additional_commands:  # -------------------------------
        $ref: "#/$defs/bootstrap-additional-commands"

      capo:  # -------------------------------
        type: object
        properties:

          image_name:  # -------------------------------
            type: string

          flavor_name:  # -------------------------------
            type: string

          rootVolume:
            $ref: "#/$defs/capo-machine-rootVolume"

          network_id:  # -------------------------------
            type: string

          servergroup_id:  # -------------------------------
            type: string

          security_group_name:  # -------------------------------
            type: string

          identity_ref_secret:  # -------------------------------
            type: object
            properties:

              name:  # -------------------------------
                type: string

              clouds_yaml:  # -------------------------------
                type: object
                additionalProperties: false
                properties:

                  clouds:  # -------------------------------
                    type: object
                    additionalProperties: false
                    required:
                      - capo_cloud
                    patternProperties:

                      "(capo_cloud|.*)":  # -------------------------------
                        type: object
                        additionalProperties: true
                        required:
                          - auth
                        properties:

                          auth:  # -------------------------------
                            type: object
                            additionalProperties: true
                            required:
                              - auth_url
                              - username
                              - password
                              - project_name
                              - project_domain_name
                              - user_domain_name
                            properties:
                              auth_url:  # -------------------------------
                                type: string
                                format: uri
                              user_domain_name:  # -------------------------------
                                type: string
                              project_domain_name:  # -------------------------------
                                type: string
                              project_name:  # -------------------------------
                                type: string
                              username:  # -------------------------------
                                type: string
                              password:  # -------------------------------
                                type: string
                          region_name:  # -------------------------------
                            anyOf:
                              - type: string
                              - type: "null"
                          verify:  # -------------------------------
                            type: boolean

      capv:  # -------------------------------
        $ref: "#/$defs/capv-machine"

      capm3:  # -------------------------------
        $ref: "#/$defs/capm3-machine"

      network_interfaces:  # -------------------------------
        type: object

# lines with '# -------------------------------' correspond to keys in values.yaml
# (the rest being the JSONSchema language itself)

additionalProperties: false

# According to this thread https://gitlab.com/sylva-projects/sylva-elements/helm-charts/sylva-capi-cluster/-/issues/31#note_1543882342
# no default values are provided for required values as they must be provided by user
# non required values have sane default which may be overidden by user if necessary
required:
  - capi_providers
  - cluster_external_ip

properties:
  name:  # -------------------------------
    type: string
  air_gapped:  # -------------------------------
    type: boolean
  cis_profile:  # -------------------------------
    anyOf:
      - type: string
        enum:
          - ""
          - cis-1.6
          - cis-1.23
  default_cni:  # -------------------------------
    anyOf:
      - type: string
        enum:
          - calico
          - cilium
  capi_providers:  # -------------------------------
    type: object
    additionalProperties: false
    required:
      - infra_provider
      - bootstrap_provider
    properties:
      infra_provider:  # -------------------------------
        enum:
          - capd
          - capo
          - capv
          - capm3
      bootstrap_provider:  # -------------------------------
        enum:
          - cabpk
          - cabpr

  k8s_version:  # -------------------------------
    type: string

  control_plane_replicas:  # -------------------------------
    type: integer

  cluster_services_cidrs:  # -------------------------------
    type: array
    items:
      $ref: "#/$defs/ipv4-cidr"

  cluster_pods_cidrs:  # -------------------------------
    type: array
    items:
      $ref: "#/$defs/ipv4-cidr"

  capd:  # -------------------------------
    type: object
    additionalProperties: false
    properties:
      docker_host_socket:  # -------------------------------
        type: string
        not:
          anyOf:
            - type: string
              pattern: ^file://.*
            - type: string
              pattern: ^unix://.*

      image_name:  # -------------------------------
        type: string

  capo: # -------------------------------
    type: object

  capv: # -------------------------------
    type: object

  cluster_external_ip:  # -------------------------------
    type: string
    format: ipv4

  cluster_public_ip:  # -------------------------------
    anyOf:
      - type: string
        format: ipv4
      - type: string
        maxLength: 0

  cluster_external_ip_interfaces:  # -------------------------------
    type: array
    items:
      type: string

  metallb_helm_oci_url: # -------------------------------
    type: string
    anyOf:
      - pattern: "^oci://.*"
      - const: ""

  metallb_helm_version: # -------------------------------
    type: string

  dns_resolver:  # -------------------------------
    type: boolean

  enable_longhorn:
    type: boolean

  mgmt_cluster_external_ip:  # -------------------------------
    type: string
    format: ipv4

  mgmt_cluster_external_domain:  # -------------------------------
    type: string
    format: hostname

  ntp:  # -------------------------------
    type: object
    additionalProperties: false
    patternProperties:
      enabled:
        type: boolean
      servers:
        type: array
        items:
          anyOf:
            - type: string
              format: ipv4
            - type: string
              format: hostname

  proxies:  # -------------------------------
    type: object
    additionalProperties: false
    patternProperties:
      https?_proxy:  # -------------------------------
        type: string
        pattern: "^(https?://.*|)$"
      no_proxy:  # -------------------------------
        type: string
    required:
      - http_proxy
      - https_proxy
      - no_proxy

  registry_mirrors:  # -------------------------------
    type: object
    additionalProperties: false
    properties:
      default_settings:  # -------------------------------
        type: object
      hosts_config:  # -------------------------------
        type: object
        additionalProperties: false
        patternProperties:
          "^[a-z0-9][a-z0-9.-]*[a-z0-9]$":  # -------------------------------
            type: array
            items:
              type: object
              additionalProperties: false
              properties:
                registry_settings: # -------------------------------
                  type: object
                mirror_url:  # -------------------------------
                  type: string
                  format: uri
                  pattern: "^(https?://.*|)$"

  bgp_lbs:  # -------------------------------
    type: object
    additionalProperties: false
    properties:
      kube_vip:  # -------------------------------
        type: object
        additionalProperties: false
        properties:
          bgp_routerid:  # -------------------------------
            type: string
            format: ipv4
          bgp_routerinterface:  # -------------------------------
            type: string
          bgp_sourceif:  # -------------------------------
            type: string
          bgp_sourceip:  # -------------------------------
            type: string
            format: ipv4
          bgp_as:  # -------------------------------
            type: integer
          bgp_peers:  # -------------------------------
            type: string
          vip_cidr:  # -------------------------------
            type: integer
      metallb:  # -------------------------------
        type: object
        additionalProperties: false
        properties:
          address_pools: # -------------------------------
            type: array
            items:
              type: object
              required:
                - name
                - addresses
              properties:
                name: # -------------------------------
                  type: string
                addresses: # -------------------------------
                  type: array
                  items:
                    anyOf:
                      - $ref: "#/$defs/ipv4-cidr-full"
                      - $ref: "#/$defs/ipv4-range"
          l3_options: # -------------------------------
            type: object
            additionalProperties: false
            properties:
              bgp_peers: # -------------------------------
                type: array
                items:
                  type: object
                  required:
                    - name
                    - local_asn
                    - peer_asn
                    - peer_address
                  properties:
                    name: # -------------------------------
                      type: string
                    local_asn: # -------------------------------
                      type: integer
                      minimum: 1
                      maximum: 4294967295  # 2**32
                    peer_asn: # -------------------------------
                      type: integer
                      minimum: 1
                      maximum: 4294967295  # 2**32
                    peer_address: # -------------------------------
                      type: string
                      format: ipv4
                    advertised_pools: # -------------------------------
                      type: array
                      items:
                        type: string

  capm3:  # -------------------------------
    type: object
    additionalProperties: false
    properties:

      public_pool_name:  # -------------------------------
        type: string

      public_pool_network:  # -------------------------------
        type: string
        format: ipv4

      public_pool_gateway:  # -------------------------------
        type: string
        format: ipv4

      public_pool_end:  # -------------------------------
        type: string
        format: ipv4

      public_pool_start:  # -------------------------------
        type: string
        format: ipv4

      public_pool_prefix:  # -------------------------------
        $ref: "#/$defs/ipv4-prefix"

      provisioning_pool_name:  # -------------------------------
        type: string

      provisioning_pool_network:  # -------------------------------
        type: string
        format: ipv4

      provisioning_pool_gateway:  # -------------------------------
        type: string
        format: ipv4

      provisioning_pool_end:  # -------------------------------
        type: string
        format: ipv4

      provisioning_pool_start:  # -------------------------------
        type: string
        format: ipv4

      provisioning_pool_prefix:  # -------------------------------
        $ref: "#/$defs/ipv4-prefix"

      dns_server:  # -------------------------------
        type: string
        format: ipv4

      machine_image_url:  # -------------------------------
        type: string
        pattern: "^(https?://.*|)$"

      machine_image_format:  # -------------------------------
        type: string

      machine_image_checksum:  # -------------------------------
        type: string
        pattern: "^(https?://.*|)$"

      machine_image_checksum_type:  # -------------------------------
        type: string

      provisioning_pool_interface:  # -------------------------------
        type: string

      public_pool_interface:  # -------------------------------
        type: string

      networkData:  # -------------------------------
        type: object
        additionalProperties: false
        properties:

          provisioning_pool_interface:  # -------------------------------
            type: object
            properties:
              routes: # -------------------------------
                $ref: "#/$defs/capm3-NetworkDataRoutev4"

          public_pool_interface:  # -------------------------------
            type: object
            properties:
              routes: # -------------------------------
                $ref: "#/$defs/capm3-NetworkDataRoutev4"

  images: # -------------------------------
    type: object
    additionalProperties: false
    properties:

      vsphere_csi_node:  # -------------------------------
        type: object
        properties:

          node_driver_registrar:  # -------------------------------
            $ref: "#/$defs/container-image"

          vsphere_csi_node:  # -------------------------------
            $ref: "#/$defs/container-image"

          liveness_probe:  # -------------------------------
            $ref: "#/$defs/container-image"

      vsphere_csi_controller:  # -------------------------------
        type: object
        properties:

          csi_attacher:  # -------------------------------
            $ref: "#/$defs/container-image"

          vsphere_csi_controller:  # -------------------------------
            $ref: "#/$defs/container-image"

          liveness_probe:  # -------------------------------
            $ref: "#/$defs/container-image"

          vsphere_syncer:  # -------------------------------
            $ref: "#/$defs/container-image"

          csi_provisioner:  # -------------------------------
            $ref: "#/$defs/container-image"

      vsphere_cloud_controller_manager:  # -------------------------------
        $ref: "#/$defs/container-image"

      kube_vip:  # -------------------------------
        $ref: "#/$defs/container-image"

  kubelet_extra_args:  # -------------------------------
    type: object

  rke2:  # -------------------------------
    $ref: "#/$defs/rke2"

  kubeadm:  # -------------------------------
    $ref: "#/$defs/kubeadm-users"

  control_plane: # -------------------------------
    type: object
    additionalProperties: false
    properties:

      kubelet_extra_args:  # -------------------------------
        type: object

      rke2:  # -------------------------------
        $ref: "#/$defs/rke2"

      kubeadm:  # -------------------------------
        $ref: "#/$defs/kubeadm-users"

      additional_commands:  # -------------------------------
        $ref: "#/$defs/bootstrap-additional-commands"

      capo:  # -------------------------------
        type: object
        properties:

          image_name:  # -------------------------------
            type: string

          flavor_name:  # -------------------------------
            type: string

          rootVolume:  # -------------------------------
            $ref: "#/$defs/capo-machine-rootVolume"

      capv:  # -------------------------------
        $ref: "#/$defs/capv-machine"

      capm3:  # -------------------------------
        $ref: "#/$defs/capm3-machine"

      network_interfaces:  # -------------------------------
        type: object

  machine_deployment_default: # -------------------------------
    $ref: "#/$defs/machine-deployment"

  machine_deployments: # -------------------------------
    type: object
    patternProperties:

      "^[a-z0-9][a-z0-9-]*[a-z0-9]$":  # -------------------------------
        $ref: "#/$defs/machine-deployment"

  baremetal_host_default: # -------------------------------
    $ref: "#/$defs/baremetal-host"

  baremetal_hosts: # -------------------------------
    type: object
    patternProperties:

      "^[a-z0-9][a-z0-9-]*[a-z0-9]$":  # -------------------------------
        $ref: "#/$defs/baremetal-host"

  apiVersions: # -------------------------------
    type: object
    additionalProperties: false
    patternProperties:
      ^[A-Za-z0-9]+$:
        type: string

allOf:
  - if:
      properties:
        capi_providers:
          properties:
            infra_provider:
              const: capo
    then:
      required:
        - capo
      properties:
        capo:  # -------------------------------
          type: object
          additionalProperties: false
          properties:

            image_name:  # -------------------------------
              type: string

            flavor_name:  # -------------------------------
              type: string

            rootVolume:
              $ref: "#/$defs/capo-machine-rootVolume"

            control_plane_az:
              type: array
              items:
                type: string

            ssh_key_name:  # -------------------------------
              type: string

            network_id:  # -------------------------------
              type: string

            control_plane_servergroup_id:  # -------------------------------
              type: string

            worker_servergroup_id:  # -------------------------------
              type: string

            control_plane_security_group_name:  # -------------------------------
              type: string

            worker_security_group_name:  # -------------------------------
              type: string

            clouds_yaml:  # -------------------------------
              type: object
              additionalProperties: false
              properties:

                clouds:  # -------------------------------
                  type: object
                  additionalProperties: false
                  required:
                    - capo_cloud
                  patternProperties:

                    "(capo_cloud|.*)":  # -------------------------------
                      type: object
                      additionalProperties: true
                      required:
                        - auth
                      properties:

                        auth:  # -------------------------------
                          type: object
                          additionalProperties: true
                          required:
                            - auth_url
                            - username
                            - password
                            - project_name
                            - project_domain_name
                            - user_domain_name
                          properties:
                            auth_url:  # -------------------------------
                              type: string
                              format: uri
                            user_domain_name:  # -------------------------------
                              type: string
                            project_domain_name:  # -------------------------------
                              type: string
                            project_name:  # -------------------------------
                              type: string
                            username:  # -------------------------------
                              type: string
                            password:  # -------------------------------
                              type: string
                        region_name:  # -------------------------------
                          anyOf:
                            - type: string
                            - type: "null"
                        verify:  # -------------------------------
                          type: boolean

            cacert:  # -------------------------------
              type: string

            resources_tag:  # -------------------------------
              type: string

  - if:
      properties:
        capi_providers:
          properties:
            infra_provider:
              const: capv
    then:
      properties:
        capv:  # -------------------------------
          type: object
          additionalProperties: false
          properties:

            dataCenter:  # -------------------------------
              type: string

            username:  # -------------------------------
              type: string

            password:  # -------------------------------
              type: string

            image_name:  # -------------------------------
              type: string

            diskGiB:  # -------------------------------
              type: integer

            memoryMiB:  # -------------------------------
              type: integer

            numCPUs:  # -------------------------------
              type: integer

            networks:  # -------------------------------
              type: object
              additionalProperties: true
              patternProperties:

                "^[a-z0-9][a-z0-9-]*[a-z0-9]$":
                  type: object
                  additionalProperties: false
                  properties:

                    dhcp4:
                      type: boolean
                    networkName:
                      type: string

                  required:
                    - networkName

            server:  # -------------------------------
              type: string

            dataStore:  # -------------------------------
              type: string

            tlsThumbprint:  # -------------------------------
              type: string

            ssh_key:  # -------------------------------
              type: string

            folder:  # -------------------------------
              type: string

            resourcePool:  # -------------------------------
              type: string

            storagePolicyName:  # -------------------------------
              type: string

            template_clone_mode:  # -------------------------------
              type: string
              enum:
                - "linkedClone"
                - "fullClone"

            storageClass:  # -------------------------------
              type: object
              properties:

                storagePolicyName:  # -------------------------------
                  type: string

                fsType:  # -------------------------------
                  type: string

  - if:
      properties:
        dns_resolver:
          const: true
      required:
        - dns_resolver
    then:
      required:
        - mgmt_cluster_external_ip  # -------------------------------
        - mgmt_cluster_external_domain  # -------------------------------

  - if:
      properties:
        capi_providers:
          properties:
            bootstrap_provider:
              const: cabpr
    then:
      required:
        - cis_profile
